package ms.warpzone.warppay.data.models.local;

import android.util.Log;

import com.activeandroid.Model;
import com.activeandroid.annotation.Column;
import com.activeandroid.annotation.Table;
import com.activeandroid.query.Delete;
import com.activeandroid.query.Select;

import java.util.ArrayList;
import java.util.List;

@Table(name = "Products")
public class Product extends Model {

    @Column(name = "pid")
    private int pid;

    @Column(name = "name")
    private String name;

    @Column(name = "category")
    private String category;

    @Column(name = "barcode")
    private String barcode;

    @Column(name = "position")
    private float position;

    @Column(name = "price")
    private float price;

    @Column(name = "count")
    private int count;

    public Product() {
        super();
    }

    public Product(int pid, String name, String category, float price, int count, float position) {
        super();
        this.pid = pid;
        this.name = name;
        this.category = category;
        this.price = price;
        this.count = count;
        this.position = position;
    }

    public static ArrayList<Product> getAllWithoutBarcode() {
        return new Select()
                .from(Product.class)
                .where("barcode = ''")
                .execute();
    }


    public int getPid() {
        return pid;
    }

    public void setPid(int pid) {
        this.pid = pid;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getCategory() {
        return category;
    }

    public void setCategory(String category) {
        this.category = category;
    }

    public float getPrice() {
        return price;
    }

    public void setPrice(float price) {
        this.price = price;
    }

    public int getCount() {
        return count;
    }

    public void setCount(int count) {
        this.count = count;
    }

    public String getBarcode() {
        return barcode;
    }

    public void setBarcode(String barcode) {
        this.barcode = barcode;
    }

    public float getPosition() {
        return position;
    }

    public void setPosition(float position) {
        this.position = position;
    }

    public static List<Product> getAll() {
        return new Select()
                .from(Product.class)
                .execute();
    }

    public static void deleteAll() {
        new Delete().from(Product.class).execute();
    }

    public String toString() {
        return this.name + " " + this.category+" "+this.barcode;
    }

    public static List<Product> getByCategory(String category) {
        return new Select()
                .from(Product.class)
                .where("category = ?", category)
                .orderBy("position")
                .orderBy("name")
                .execute();
    }

    public static Product getOneByName(String product_name) {
        return new Select()
                .from(Product.class)
                .where("name = ?", product_name)
                .executeSingle();
    }

    public static Product getOneByBarcode(String barcode) {
        return new Select()
                .from(Product.class)
                .where("barcode = ?", barcode)
                .executeSingle();
    }
}
